from .entropy import Entropy_numeric
import numpy as np

class Entropy_toy(Entropy_numeric):
    def __init__(self, summarytype, kernel):
        super().__init__(summarytype, kernel)

    def get_all_lines(self, points):
        all_lines = []
        for i in range(len(points)):
            for j in range(i, len(points)):
                point1 = points[i]
                point2 = points[j]
                if not (np.array_equal(point1, point2)):
                    all_lines.append([point1, point2])
        return np.array(all_lines)

    def get_newlines(self, point, sensors):
        lines = []
        point = point[0]
        for point2 in sensors:
            lines.append([point, point2])
        return lines

    def initial_point(self, lines):
        scores = []
        for i in range(len(lines)):
            l = [lines[i]]
            s = self.K.kernel(l, l)
            scores.append(s)

        return np.argmax(np.array(scores))

    def delete_point(self, points, point):
        i = np.argmax(np.logical_and(points[:, 0] == [point[0]], points[:, 1] == [point[1]]))
        return np.delete(points, i, axis=0)

    def initialize(self, points):
        all_lines = self.get_all_lines(points)
        initial = self.initial_point(all_lines)
        line = all_lines[initial]
        sensors = [line[0], line[1]]
        points = self.delete_point(points, line[0])
        points = self.delete_point(points, line[1])
        return [line], sensors, points

    def get_nextlines(self, A, chosen, points):
        Kaa_inv = self.K_inverse(np.array(A))
        scores, lines = self.scores(Kaa_inv, np.array(A), points, chosen)
        ind = np.argmax(scores)
        chosen = points[ind]
        points = np.delete(points, ind, axis=0)

        return lines[ind], chosen, points


